%%%-------------------------------------------------------------------
%%% File    : connection_pool_sup.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : Connection pool supervisor
%%%
%%% Created : 15 Dec 2002 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id$
%%
%% $Log$
%%
%%**
%% 
%% @doc Connection pool supervisor
%% @end
%%*
-module(connection_pool_sup).

-behaviour(supervisor).
%%--------------------------------------------------------------------
%% Include files
%%--------------------------------------------------------------------

%%--------------------------------------------------------------------
%% External exports
%%--------------------------------------------------------------------
-export([start_link/1, start_child/1]).

%%--------------------------------------------------------------------
%% Internal exports
%%--------------------------------------------------------------------
-export([init/1]).

%%====================================================================
%% External functions
%%====================================================================
%%--------------------------------------------------------------------
%% Function: start_link/0
%% Description: Starts the supervisor
%%--------------------------------------------------------------------
start_link(Spec) ->
  supervisor:start_link(?MODULE, Spec).

start_child(Pid) ->
  supervisor:start_child(Pid, []).

%%====================================================================
%% Server functions
%%====================================================================
%%--------------------------------------------------------------------
%% Func: init/1
%% Returns: {ok,  {SupFlags,  [ChildSpec]}} |
%%          ignore                          |
%%          {error, Reason}   
%%--------------------------------------------------------------------
init(Spec) ->
  {ok, Spec}.

%%====================================================================
%% Internal functions
%%====================================================================
