%%% File    : lambda.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  7 Jan 2003 by  <svg@surnet.ru>

%%
%% $Id$
%%
%% $Log$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(svglib.lambda).

-export([y/1, ya/2, fact/1, mk_fact1/0, mk_wrap/1, mk_max/0]).

-import(.io).

y(X) ->
  F = fun (P) -> X(fun (Arg) -> (P(P))(Arg) end) end,
  F(F).

ya(A, X) ->
  F = fun (P) -> X(fun (Arg) -> A(P(P), Arg) end) end,
  F(F).

um(Myapply, F)  ->
  G = fun (V) ->
	  fun (Args) -> Myapply(F(V), Args) end
      end,
  F(G).

fact(FA) ->
  fun (N) ->
      if (N == 0) -> 1;
	 true -> N * FA(N-1)
      end
  end.

mk_fact1() ->
  Apply =
    fun (F, A) ->
        R=apply(F, [A]),
        io:format("arg:~p, result:~p~n", [A, R]),
        R
    end,
  ya(Apply, fun fact/1).

mk_wrap(FA) ->
  fun (Arg) ->
      Result = FA(Arg),
      io:format("result:~w~n", [Result]),
      Result
  end.

mk_max() ->
  F =
    fun (FA) ->
	fun ([]) ->
	    {error, empty};
	    ([E]) ->
	    E;
	    ([E|Rest]) ->
	    RestMax = FA(Rest),
	    if (E > RestMax) ->
		E;
	       true ->
		RestMax
	    end
	end
    end,
  y(F).
