%%% File    : misc.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 10 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id$
%%
%% $Log$
%%
%%**
%% 
%% @doc Miscellaneous functions
%% @end
%%*
-module(svglib.misc).

-export([better_error/1]).

%%**
%% @type error() = {error, Error}
%%      Error = term().
%% 
%% @spec better_error(Error::term()) -> Return::error()
%%
%% @doc Try to convert catched result to error return format
%%      user expected
%%
%% @end
%%*
better_error({'EXIT', {{badmatch, Error}, _}}) ->
  better_error(Error);
better_error({aborted, Reson}) ->
  {error, mnesia:error_description(Reson)};
better_error({'EXIT', Error}) ->
  better_error(Error);
better_error(Error={error, _}) ->
  Error;
better_error(Error) ->
  {error, Error}.
